var fs = require('fs');
var path = require('path');

var scriptPath = __dirname;
var destinationFile = "";
var templatesFolder = "";
var split;
var arg;
var argValue;

console.log (scriptPath);
process.argv.forEach(function (val, index, array) {
    split    = val.split("=");
    arg      = split[0];
    argValue = split[1];

    if (arg == "dest") {
        destinationFile = argValue;
    } else if (arg == "folder") {
        templatesFolder = argValue + '/'
    }
});

var getFolderFiles = function (folderPath, callback) {
    fs.readdir(folderPath, function (err, files) {
        callback(files);
    })
};

var getFileContent = function (filepath) {
    return fs.readFileSync(filepath, {encoding: 'utf8'});
};

var replaceInSource = function (sourceFile, content, pattern) {
    var sourceFileContent = getFileContent(sourceFile);

    sourceFileContent = sourceFileContent.replace(pattern, content);

    fs.writeFile(sourceFile, sourceFileContent, function (err) {
        if (err) {
            return console.log(err);
        }
        console.log("Template files injected !");
    });
};

var files = getFolderFiles(templatesFolder, function (files) {

    var tag = '<script type="text/template" id="%id%">\n%content%\n</script>';
    var content;
    var filename;
    var result;
    var contentList = [];

    for (var f in files) {
        filename = files[f];
        content = getFileContent(templatesFolder + filename);

        result = tag.replace('%id%', filename.replace('.html', ''));
        result = result.replace("%content%", content);

        contentList.push(result);
    }

    replaceInSource(destinationFile, contentList.join("\n"), '<!-- #! template -->');
});





